{{  XBeeComTest110202d

  
}}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  '' Pin asignments
 
  _XBee0RxPin = 7               ' if you're not using XBees connect this to _XBee1RxPin
  _XBee0TxPin = 6               ' if you're not using XBees connect this to _XBee1TxPin
  _XBee0CtsPin = -1 '12
  _XBee0RtsPin = -1 '13
  _XBee1RxPin = 9
  _XBee1TxPin = 8
  _XBee1CtsPin = -1 '14 '
  _XBee1RtsPin = -1 '15
  _Debug1RxPin = 11
  _Debug1TxPin = 10
  
  _RtsThreshold = 0 '495
  
  _DebugBaud = 57600 '9600 4800 '   
 
  _XBeeBaud = 9600

  _XBeeTimeout = 280_000_000 ' 80_000_000 per second  3.5 seconds
  _XBeeTimeoutRx = 60_000_000 '40_000_000 '  1/2 second may need adjusting
  
  _XBeeRxtime = 250             ' quarter of a second, decrease when there are few debug statements.
 
  _XBeeSerialSize = 8
  _XBeeNameFieldSize = 12


  _LargeBufferSize = 512 '128 '32


  ' Com enumeration
  #0, _XBeeCom0, _XBeeCom1, _DebugCom

  
VAR

  long rxFlag[4], oldRxFlag[4]
 
  byte endChar
  byte linesToExpectCom[4], endOfTransExceptionFlag, tempBuffer[_LargeBufferSize]
  
OBJ

  Com : "pcFullDuplexSerial4FC512Flags110301a" 
  
PUB Main | count[14], localIndex, localCharacter, localCount, localSize, localXbee

  waitcnt(clkfreq * 2 + cnt) 
  endChar := 13
  linesToExpectCom[_XBeeCom0] := 1
  linesToExpectCom[_DebugCom] := 1
  linesToExpectCom[_XBeeCom1] := 1
  linesToExpectCom[3] := 1
  
 
  Com.AddPort(_XBeeCom0, _XBee0RxPin, _XBee0TxPin, _XBee0CtsPin, _XBee0RtsPin, _RtsThreshold, 0, _XBeeBaud) 
  Com.AddPort(_XBeeCom1, _XBee1RxPin, _XBee1TxPin, -1, -1, 0, 0, _XBeeBaud)
  Com.AddPort(_DebugCom, 31, 30, -1, -1, 0, 0, _DebugBaud)
  
  Com.SetFlags(endChar, endChar, endChar, endChar, @rxFlag[0])

  Com.Start


  repeat    
    count[0]++
    localCharacter := Com.rxcheck(_DebugCom)
    if localCharacter == "0"
      Com.str(_XBeeCom0, @xbee0Output1)
    elseif localCharacter == "1"
      Com.str(_XBeeCom1, @xbee1Output1)
 
    repeat localIndex from _XBeeCom0 to _XBeeCom1       
      repeat while rxFlag[localIndex] <> oldRxFlag[localIndex]      
        localSize := FlushBuffer(localIndex)
        Tbug(string("XBee #"))
        TbugDec(localIndex)
        Tbug(string(" received: "))
        SafeBug(@tempBuffer, localSize)
    
PRI FlushBuffer(localBufferIndex) | localCharacter, localIndex, linesOut', previousWirelessCharacter

   if rxFlag[localBufferIndex] == oldRxFlag[localBufferIndex]                              
    Tbug(string(13, "No buffer data, rxFlag["))
    TbugDec(localBufferIndex)
    Tbug(string("] = "))
    TbugDec(rxFlag[localBufferIndex])
    return 0

  localIndex := 0
  linesOut := linesToExpectCom[localBufferIndex]
  repeat while linesOut > 0
    if localIndex => _LargeBufferSize
      Tbug(string(13, "tempBuffer full!", 13))
      Tbug(string("This shouldn't happen.", 13)) 
      quit
    localCharacter := Com.rxcheck(localBufferIndex)
    if localCharacter == -1
      Tbug(string(13, "rx buffer empty!!!", 13))
      Tbug(string("Data is missing!!!", 13))
      localCharacter := endChar
    tempBuffer[localIndex] := localCharacter
  
    if localCharacter == endChar 
      linesOut--
    localIndex++
  tempBuffer[localIndex] := 0   ' is this needed?

  oldRxFlag[localBufferIndex]++
 
  result := localIndex 

PUB SafeBug(localPtr, localSize)

  repeat result from 0 to localSize - 1
    TbugTx(byte[localPtr + result])
      
PRI Tbug(localPtr)

  'Tv.str(localPtr)
  Com.str(_DebugCom, localPtr)

PRI TbugDec(localDec)

  'Tv.dec(localDec)
  Com.dec(_DebugCom, localDec)

PRI TbugTx(localCharacter)

  if (localCharacter > 31 and localCharacter < 127) or localCharacter == 13
    'Tv.out(localCharacter)
    Com.tx(_DebugCom, localCharacter)
  else
    'Tv.out(60)
    'Tv.out(36)
    Com.tx(_DebugCom, 60)
    Com.tx(_DebugCom, 36)
    TbugHex(localCharacter, 2)
    'Tv.out(62)
    Com.tx(_DebugCom, 62)
    
PRI TbugHex(localHex, localSize)
 
  'Tv.hex(localHex, localSize)
  Com.hex(_DebugCom, localHex, localSize)

DAT                             
                                     '         1         2         3         4         5 
                                     '12345678901234567890123456789012345678901234567890123456789                                                                                                   
xbee0Output1                    byte "This is a message from XBee #0", 13, 0 

xbee1Output1                    byte "Hello from XBee #1", 13, 0 

      